#!/usr/bin/perl
#use strict;
require "SUBROUTINES.pl";
require "SUB_CATEGORIES.pl";
require 'config.pl';

my %expected_freqs;
#my %state_hash = make_hash ("../cities/states.csv",0,1,",");
#my %state_abbrev_to_full_hash = make_hash ("../cities/states.csv",1,0,",");
#my $outdir = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS";

my %state_hash = make_hash ($states_abbrev_file,0,1,",");
my %state_abbrev_to_full_hash = make_hash ($states_abbrev_file ,1,0,",");
#my $outdir = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS";


# initalize hash
my %categ1_hash;
my %categ2_hash;
my %c1_job_state_hash;
my %c1_religion_state_hash;
my %c1_ethnic_state_hash;

my %c1_job_hash;
my %c1_religion_hash;
my %c1_ethnic_hash;



#my %census_state_hash = make_census_state_pops ();
#my %census_freq = convert_to_freqs (%census_state_hash);

foreach my $s (keys %state_hash) {
        my %new_hash;
        my %new_hash_1;
	my %new_hash_2;
	my %new_hash_3;
	my %new_hash_4;
	my %new_hash_5;
#	print "state $s\n";
        $state_hash{$s}=\%new_hash;
	$categ1_hash{$s} = \%new_hash_1;
	$categ2_hash{$s} = \%new_hash_2;
	$c1_job_state_hash{$s} = \%new_hash_3;
	$c1_religion_state_hash{$s} = \%new_hash_4;
	$c1_ethnic_state_hash{$s} = \%new_hash_5;
}

my @decades = qw (1940 1950 1960 1970 1980);
my $decade;
foreach $decade (@decades) {
for (my $year = $decade; $year < $decade+10; $year++) {

my $birthplace_file = $outdir . #"/home/pauline/wiki/wiki_entries
				"/$decade/$year.allbirthplace";

open (IN, $birthplace_file) || die "can't open $birthplace_file\n";
my $line; 
while ($line = <IN>) {
	chomp ($line);
#	print $line . "\n";
	my @fields = split (/\t/, $line);
	my $categ_index = 0;;
	my $found_job_categ  = 0;
	my $found_ethnic_categ = 0;
	my $found_religion_categ = 0;

	while ($categ_index < @fields && 
		!($fields[$categ_index] =~ /Categories/) ) {
		$categ_index++;
	}
	if ($fields[$categ_index] =~ /Categories/) {
		my $categ = $fields[$categ_index];
		my $loc = index ($categ,"Hidden categories");
		if ($loc > 0) {
			$categ = substr ($categ,0,$loc-1);
		}
	$categ =~ s/Categories://;
	$categ =~ s/ \| /\|/g;
#	print "categ is $categ\n";
	my @categ_array = split (/\|/, $categ);
	my $birthcity = $fields[3];
	$_ = $birthcity;
	/\, ([A-Za-z\ ]+)\:/;
	my $state = $1;
	if (exists ($state_abbrev_to_full_hash{$state} )) {
		$state = $state_abbrev_to_full_hash{$state} ;
	}	
	if (exists ($state_hash{$state})) {

#print "in here\n";
		for (my $i=0; $i < @categ_array;  $i++) {
#print "in here\n";
			my $c = $categ_array[$i];
			$c =~ s/^\s+//g;
			$c =~ s/\s+$//g;
			$expected_freqs{$c}++;
#			print "state $state cat $c\n";
			$state_hash{$state}{$c}++;	
			my $birthplace_file = $outdir . 
	#"/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/
			"$decade/$year.allbirthplacecleanUS";

			if (!$found_job_categ) {
				my ($c1, $c2 ) = get_job_categories ($c);	
				if ($c1 ne "") {
					$c1_job_state_hash{$state}{$c1}++;
					$c1_job_hash{$c1}++;
					$found_job_categ=1;
					print_out ($birthplace_file, $c1, 
					$line);
					print_out_by_state ($birthplace_file, $c1, $c2, $line, $state); 
				}
			}
			if (!$found_ethnic_categ) {
				my ($c1, $c2 ) = get_ethnic_category ($c);
                                if ($c1 ne "") {
                                        $c1_ethnic_state_hash{$state}{$c1}++;
                                        $c1_ethnic_hash{$c1}++;
					$found_ethnic_categ=1;
					print_out ($birthplace_file, $c2,
                                           $line );

                                }
                        }
			if (!$found_religion_categ) {
                                my ($c1, $c2 ) = get_religion_category ($c);
                                if ($c1 ne "") {
                                        $c1_religion_state_hash{$state}{$c1}++;
                                        $found_religion_categ=1;
					$c1_religion_hash{$c1}++;
					print_out ($birthplace_file, $c2,
                                                                        $line);

                                }
                        }

		} # end for loop 
		if (!$found_religion_categ && !$found_ethnic_categ &&
			!$found_job_categ) {
			print "who's this person $line\n";
		}	
	}
	} # end category index found if statement
	else {
		print "no found category $line\n";
	}
}
close (IN);
} # end for year
} # end for decade


print "Job\n";
print_c1_hash (\%c1_job_hash, \%c1_job_state_hash);

print "Ethnicity\n";
print_c1_hash (\%c1_ethnic_hash, \%c1_ethnic_state_hash);

print "Religion\n";
print_c1_hash (\%c1_religion_hash , \%c1_religion_state_hash);

foreach my $categ (keys (%expected_freqs)) {
#if ($expected_freqs{$categ} >= 10) {
#print "$categ\t" .  $expected_freqs{$categ} . "\n";
#}
	foreach my $state (keys %state_hash) {
		my $observed_freq_of_category_in_state = 
					$state_hash{$state}{$categ} /
					$expected_freqs{$categ};
#	my $expected_freq_of_state_relative_to_US = ;
	# read from another file
if ($state_hash{$state}{$categ} > 0 && $expected_freqs{$categ} >= 10 ) {
#print "$categ\t$state\t" . $state_hash{$state}{$categ} . 
#		"\t" . $expected_freqs{$categ}
#	. "\t" . "$observed_freq_of_category_in_state\n";
}

	} # end foreach state 
}
exit (0);

sub
print_out 
{
	my ($birthplace_file, $suffix, $line) = @_; 
	my $outfile = $birthplace_file . "." . $suffix ;
	my @fields = split (/\s+/, $line);
	$_ = $line;
	my %clean_lines = make_hash ($birthplace_file, 0,,);
	if (exists ($clean_lines{$fields[0]})) { 
	/Birthcity:(.*):[0-9]/;
	my $place = $1;
	#my $line2 = $fields[0] . "\t" . $fields2[1] . "\n";
	open (OUT, ">>$outfile") || die "can't open $outfile";
	#print OUT $fields[0] . "\t" . $place . "\n";
	print OUT $clean_lines{$fields[0]} . "\n";
	close (OUT);                                                    

	}
	else {
		print "couldn't find $fields[0] \n";
	}
}

sub
print_out_by_state
{
        my ($birthplace_file, $c1, $c2, $linet, $state) = @_;
        my @fields = split (/\s+/, $linet);
        $_ = $linet;
        my %clean_lines = make_hash ($birthplace_file, 0,,);
        if (exists ($clean_lines{$fields[0]})) {
        /Birthcity:(.*):[0-9]/;
        my $place = $1;
        my $line = $clean_lines{$fields[0]};
	my $loc = rindex ($line, ",");
#	my $state = substr ($line, $loc+1, 1000);
	$state =~ s/^\s+//g; $state =~ s/\s+$//g;
	$state =~ s/\s+/\_/g;
	print "state is $state from $line\n";
	my @fields2 = split (/\s+/, $line);
	my $wiki_link = $fields2[0];
	print "wiki link is $wiki_link\n";
	my $outfile = $outdir . "/famous_people_categs." . $state;
	#my $line2 = $fields[0] . "\t" . $fields2[1] . "\n";
        open (OUT, ">>$outfile") || die "can't open $outfile";
        #print OUT $fields[0] . "\t" . $place . "\n";
        print OUT $wiki_link . "\t" . $c1 . "\t" . $c2 . "\n";
        close (OUT);

        }
        else {
                print "couldn't find $fields[0] \n";
        }
}

sub
print_c1_hash 
{
	my ($total_c1_hash_ref, $c1_state_hash_ref)
					 =@_;
	my %c1_state_hash = %{$c1_state_hash_ref};
	my %total_c1_hash = %{$total_c1_hash_ref};

	my @categs = keys (%total_c1_hash) ;
	my @states = keys (%c1_state_hash);

	for (my $j = 0; $j < @categs; $j++) {
		my $categ = $categs[$j];
		my $total_c1 = $total_c1_hash{$categ};
		for (my $i = 0 ; $i < @states; $i++) {
			my $state = $states[$i];
			print "$state $categ $c1_state_hash{$state}{$categ} " .
				$c1_state_hash{$state}{$categ}/$total_c1 . "\n";
		}
	} # end for states

} 
