#!/usr/bin/perl;
#use strict;
my @decades = qw (1940 1950 1960 1970 1980 1990 2000 2010);
my $decade;
require 'config.pl';

#my $wiki_dir =  "../wiki_entries_test/";

foreach $decade (@decades) {
for (my $year = $decade; $year < $decade+10; $year++) {
my $file = $wiki_dir . "/$decade/$year.allbirthplace";
my $outfile = $file . "cleanUS";

open (IN, $file) || die "can't open $file";
open (OUT, ">$outfile") || die "can't open $outfile";

my $line;
while ($line = <IN>) {
	my @fields  = split (/\t/, $line);
	my ($wiki,  $name) = split (/\s+/, $fields[0]);
	if ($fields[1] =~ /U\.S\./) {
		# US citizen
		$fields[3] =~ s/Birthcity://;
		my ($place, $count) = split (/\:/, $fields[3]);
		$place =~ s/^Born //;
		my (@places) = split (/\,/, $place);
		# sometimes city has county like San Gabriel, Los Angeles, California
		# take the first and last		
		my $city = $places[0];
		my $state = $places[$#places];
		$place = $city . ", " . $state; 
		if ($count < 10 && $place ne "" ) { 
			print OUT $wiki . "\t" . $place . "\t" . $fields[4] . "\n";
		}
	}

} # finished reading file 
close (IN);  
close (OUT);
} # end year
} # end decade
