

use POSIX;
use Class::Struct;

# returns hash for a file, 2nd field is the key and the 3rd field
# is the value 4th field, is the delimiter
sub
make_hash
{
	my ($file, $keyindex, $valueindex, $delimiter) = @_;
	my %hash;	
	open (HASH, $file) || die "can't open $file";
	my $line; 
	while ($line = <HASH>) {
		chomp ($line);;
		my @fields ;
		if ($delimiter eq "") {
			@fields = split (/\s+/, $line);
		} else {
			@fields = split (/$delimiter/, $line);
		}
#print "fields key $fields[$keyindex] value $fields[$valueindex]\n";
		if ($valueindex eq "") {
			 $hash{$fields[$keyindex]} = $line;
		} else {
			$hash{$fields[$keyindex]} = $fields[$valueindex];
		}
	}
	close (HASH);
	return (%hash);	
}
1;

