#!/usr/local/bin/perl -w
#use strict;
use POSIX; 
$| = 1;
require 'config.pl';

#my $wiki_dir = "../wiki_entries_test/";

for (my $decade = 1940; $decade <= 2010 ; $decade += 10) {
for (my $year = $decade; $year < $decade + 10; $year++) {
my $infile = $wiki_dir . $decade . "/" . $year . ".all"; 
my $outdir = $wiki_dir . $decade . "/" . $year  ;

my $outfile = $infile . "birthplace";

#       "../international_and_domestic_locations",
my %places_hash = make_hash ($countries_file, 
				0,1, "\t");
# "../states_in_US"
my %states_hash = make_hash ($states_file,0,1,"\t");

open (IN, $infile) || die "can't open $infile\n";
open (OUT, ">$outfile") || die "can't open $outfile";
my $line;

while ($line = <IN>) {
	chomp ($line);
	my @fields =split (/\s+/, $line);;

	my $name_string = $fields[0];
	$name_string =~ s/\/wiki\///;
	 $name_string =~ s/\//_/g;
	$name_string =~ s/\(/\\\(/g;
	$name_string =~ s/\)/\\\)/g;
	
	my $wiki_filename = $outdir . "/" . $name_string;
#if ($name_string =~ /Wys/ || $name_string =~ /Schiff/) {	
	 my @lines = `cat $wiki_filename`; 

#	my $num_references=0;
	my @born_sentences;
	my $nickname = "";
	print "reassigning categories line null\n";
	my $categories_line = "";

	#start of sentence with birthdate year in it
	my $i =0; my $done = 0; my $categories_done = 0;
	# for some reason, if put done && categories_done in, 
	# categories_done isn't working
	for ($i = 0; $i < @lines ; $i++) {
#print "in for loop $i $lines[$i]\n";
		if ($lines[$i] =~ /^[A-Z]/ && 
			$lines[$i] =~ /$year/ 
			&& $lines[$i] =~ /\./) { # it's a sentence with a year#
			my $first_sentence = $lines[$i] ; 
			my $loc = index ($first_sentence, ".");
			my $loc2 = index ($first_sentence, "D.C.");
			if ($loc == $loc2 + 1) {
				# this is D.C.
				$loc = $loc + 3;
			}
			$first_sentence = substr ($first_sentence, 0, $loc);
			if ($first_sentence =~ /\"/) {
				$_ = $first_sentence;
				/\"(.*)\"/;
				$nickname = $1;
				print "nickname " . $1 . "\t$first_sentence\n";
			}
			print "first sentence is $first_sentence end first_sentence";
			push (@born_sentences, $first_sentence);
			$done = 1;
		}
		if ($lines[$i] =~ /Categories/) {
			$categories_line = $lines[$i];
			chomp ($categories_line);
			$categories_line =~ s/^\s+//g;
			$categories_done = 1;
		print "categories 234 $name_string $categories_line $line $fields[0] $name_string\n";
		} # end ccategories
#		if ($lines[$i] =~ /^References/ || $lines[$i] =~ /Notes/) {
#			do {
#			$i++; # skip newlines
#			} until ($i >= @lines || $lines[$i] =~ /\^/);
#			while ($i < @lines && $lines[$i] =~ /\^/) {
#				$num_references++;
#				$i++;
#			}
#		}

	} 
	print "done with for is $i and last is " . scalar (@lines) . "\n";
#	my $tmp2 = splice (@lines,0,$i-1);
#	print "eliminating $tmp2\n";
	#any other sentences with born in it
	my $long_string = join ("\n", @lines);

	my $loc; my $loc2;	
	$loc = index (lc ($long_string), "born");
	print "loc is $loc\n";
	my $done_with_bio_table = 0;
	print "categories line is 123254 $categories_line \n";
	while ($loc >= 0 && !$done_with_bio_table) {
		$long_string = substr ($long_string, $loc, 10000000000);
		$loc2 = index ($long_string, ".");
		my $loc4 = index ($long_string, "D.C.");
                        if ($loc2 == $loc4 + 1) {
                                # this is D.C.
                                $loc2 = $loc2 + 3;
                        }

		 my $loc3 = index ($long_string, "\n\n\n");
                if ($loc3 >= 0 && $loc3 < $loc2) { 
			# this is the table on the right-hand side
			# just take this and don't parse any_longer
			$loc2 = $loc3;
			@born_sentences = (); # clear out old stuff 
			$born_sentences[0] = substr ($long_string, 0, $loc2);
			$done_with_bio_table = 1;
		}

		print "adding born " . substr ($long_string, 0, $loc2) . "\n";	
		push (@born_sentences, substr ($long_string, 0, $loc2));
		$long_string = substr ($long_string, $loc2, 1000000000);
		 $loc = index (lc ($long_string), "born");
		print "in while loop categories $categories_line\n";
	}
	my $country_string = check_birthplace (\@born_sentences, \%places_hash);
	my $city = get_city (\@born_sentences, \%states_hash); 

	print OUT $line . "\t" . $country_string . "Nickname:$nickname\tBirthcity:$city\tTotalLines:" . scalar (@lines) . "\t$categories_line\n";	

#if ($name_string =~ /Valentine/) {
#        exit(0);
#}
#} # end for  particualr names for debugging
	 	
} # end gone through all pages 
close (IN);
close (OUT);

} # gone through year
} # end for decade
exit (0);


sub
get_city
{
	my ($born_sentences_ref, $us_states_hash_ref) = @_;
	my @sentences = @{$born_sentences_ref};
	my %states_hash =  (%{$us_states_hash_ref});
	my @states_array = keys (%states_hash);
	my @possible_birthcities;

	for (my $i = 0; $i < @sentences; $i++) {
		my $match = 0; 
		my $tmp_string = $sentences[$i];
		# shorten sentence so only identify
		# "born in __, ___"  or (born ##  ## )
		if ($tmp_string =~ /[bB]orn in [A-Z][a-z]+/) {

			print "born in string $tmp_string\n"; 
			# only want the capital letters following born in string
			$tmp_string = substr ($tmp_string,8,100);
			$_ = $tmp_string;
			/(.)*\ [a-z]/;
			$tmp_string = $1; 
			print "reduced to $tmp_string\n";
		}
		if ($tmp_string ne "") {
		if ($tmp_string =~ /\) in /) {
			# born ## ## ) in #place
		}
		elsif ($tmp_string =~ /\)/) {
			my $loc = index ($tmp_string, ")");
			$tmp_string = substr ($tmp_string,0,$loc);
#			print "parantheses string $tmp_string\n";
		}	
		}
	for (my $j = 0; $j < @states_array && !$match; $j++) {
                # get rid of punctuation
		my $state_string1 = ", " . $states_array[$j];
		my $state_string2 = "," . $states_array[$j];	
		if (($sentences[$i] =~ /$state_string1/ || 
				$sentences[$i] =~ /$state_string2/) &&
			!($sentences[$i] =~ /moved/) ) {
			my $state = $states_array[$j];
			my $loc;
			if ($sentences[$i] =~ /$state_string1/) {
				$loc = rindex ($sentences[$i], $state_string1);
			} else {
				$loc = rindex ($sentences[$i], $state_string2);
			}	
			my $city_substring = substr( $sentences[$i], 0, $loc);
			my @all_words = split (/\s+/, $city_substring);
			my $city = "";
			my $word_index = $#all_words;
			while ($word_index >= 0 && 
				$all_words[$word_index] =~ /^[A-Z]/) {
				$city = $all_words[$word_index] . " " . $city;
				$word_index--;
			}
			$city =~ s/\s*,$//;
			$city =~ s/\s*$//;
			my $birthcity = $city . ", " . $state;
		#	$match = 1;
			push (@possible_birthcities, $birthcity .
							 ":" . $word_index);
#			return ($birthcity . ":" . $word_index);
		} # end match state 
	} # end gone through all states  
	} # end gone through all sentences 
print "here i am\n";
	if (@possible_birthcities == 1) {
print "in here\n";
		my ($city, $count) = split (/\:/, $possible_birthcities[0]);
#		chomp ($city);
		return ( $possible_birthcities[0]);
#		return ($city);
	} else {
		my $min_word_distance = 1000; my $min_city = "";
		for (my $t = 0; $t < @possible_birthcities; $t++) {
			my ($city, $count) = split (/\:/, $possible_birthcities[$t]);
print "city $city count $count\n";
			chomp ($city);
			if ($count < $min_word_distance) {
				$min_word_distance = $count;
				$min_city =  $possible_birthcities[$t];
			}
		} # end for loop	
		return ($min_city);
	}

	return "";
}



sub
check_birthplace
{
	my ($born_sentences_ref, $places_hash_ref) = @_;
	my @sentences = @{$born_sentences_ref};
	my %places_hash = %{$places_hash_ref};

	my $country_string = "";

	for (my $j = 0; $j < @sentences; $j++) {
		# get rid of punctuation
		$sentences[$j] =~ s/\,/ /g;
		$sentences[$j] =~ s/\./ /g;
		$sentences[$j] =~ s/\)/ /g;
		$sentences[$j] =~ s/\(/ /g;
		$sentences[$j] =~ s/\"/ /g;
		$sentences[$j] =~ s/\[/ /g;
		$sentences[$j] =~ s/\]/ /g;

		 my @fields = split (/\s+/, $sentences[$j]);
                for (my $i = 0; $i < @fields; $i++) {
                        if (exists ($places_hash{$fields[$i]}) ) {
                                $country_string .= $fields[$i] . ":" .
                                        $places_hash{$fields[$i]} . " ";
                        }
                }
                # gone through all words
        } # gone through all sentences


	if ($country_string eq "") {
		 $country_string = "can't parse: " . join (";", @sentences);
	} elsif ($country_string =~ /NonUS/ && $country_string =~ /US/) {
		$country_string = "Ambiguous\t" . $country_string;
	} elsif ($country_string =~ /NonUS/) {
		$country_string = "NON_US\t" . $country_string;
	} elsif ($country_string =~ /US/) {
		$country_string = "U.S.\t" . $country_string;
	} elsif ($country_string =~ /Ambiguous/) {
		$country_string = "Ambiguous\t" . $country_string;
	} else { 
		$country_string = "can't parse: " . join (";", @sentences); 
	}
	
	return ($country_string);

}
	
sub
get_people
{
	my ($outfile, @content) = @_;

	open (OUT, ">>$outfile") || die "can't open $outfile";
	for (my $j = 0; $j < @content; $j++) {
#print "line $j " . $content[$j] . "\n";
		if ($content[$j] =~ /^\<li\>\<a href/) {
#print "in if $content[$j]\n";
			$content[$j] =~ s/\<li\>//;
			my $loc2 = index ($content[$j] , ">");
			my $tmp_str =substr ($content[$j], 0, $loc2-1);
			$tmp_str =~ s/<a href=//;
			$tmp_str =~ s/title=//;
			$tmp_str =~ s/\"//g;
			print OUT $tmp_str . "\n"; 
		}
	}
	close (OUT);
}


sub roundup {
    my $n = shift;
    return(($n == int($n)) ? $n : int($n + 1))
}

# returns hash for a file, 2nd field is the key and the 3rd field
# is the value 4th field, is the delimiter
sub
make_hash
{
        my ($file, $keyindex, $valueindex, $delimiter) = @_;
        my %hash;
        open (HASH, $file) || die "can't open $file";
        my $line;
        while ($line = <HASH>) {
                chomp ($line);;
                my @fields ;
                if ($delimiter eq "") {
                        @fields = split (/\s+/, $line);
                } else {
                        @fields = split (/$delimiter/, $line);
                }
#print "fields key $fields[$keyindex] value $fields[$valueindex]\n";
                if ($valueindex eq "") {
                         $hash{$fields[$keyindex]} = $line;
                } else {
                        $hash{$fields[$keyindex]} = $fields[$valueindex];
                }
        }
        close (HASH);
        return (%hash);
}

