#!/usr/local/bin/perl -w
#use strict;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Response;
use HTML::Tree;
use HTML::Scrubber;
use POSIX; 
$| = 1;

require 'config.pl';

#my $wiki_dir =  "../wiki_entries_test/";

for (my $start_decade = 1940; $start_decade <= 2010; $start_decade += 10) {
for  (my $year = $start_decade; $year < $start_decade+10;  $year++) {
my $infile = $wiki_dir . $start_decade . "/" . $year . ".all"; 
my $outdir = $wiki_dir . $start_decade . "/" . $year  ;
system ("mkdir $outdir");

open (IN, $infile) || die "can't open $infile\n";
my $line;
my $scrubber = HTML::Scrubber->new;
$scrubber->default (0);

while ($line = <IN>) {
	chomp ($line);
	my @fields =split (/\s+/, $line);;

	my $browser = LWP::UserAgent->new;
#	my $URL = "http://en.wikipedia.org" . $fields[0];
	my $name_string = $fields[0];
	$name_string =~ s/\/wiki\///;
	my $URL = "http\:\/\/en\.wikipedia\.org\/w\/index.php\?title\=" . $name_string
		 . "\&printable=yes";
	# July 17,2011 , getting utf-8 error 
#	my $response =  $browser->get ($URL); 
	my $content; 
#	print $URL . "\n";
		# URL has to be exactly right else go to the mainpage
		# not UTF-8	
	my $response =  $browser->get ($URL);
	$content = $response->content;

	my $clean_content = $scrubber->scrub ($content);
		
	$name_string =~ s/\//_/g;

        my $outfile = $outdir . "/" . $name_string;

	open (OUT, ">$outfile") || die "can't open $outfile";
	print OUT $clean_content;
	close (OUT);


} # end alllines in a file
} # end year 
} # end decade
exit (0);
